## gfal2 2.23.2

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message ("cmake source dir : ${CMAKE_SOURCE_DIR}")

# default set of options
set (MAIN_CORE      TRUE CACHE STRING "enable compilation of the main library")
set (MAIN_TRANSFER  TRUE CACHE STRING "enable compilation of the transfer library")
set (PLUGIN_SFTP    TRUE CACHE STRING "enable compilation of the sftp plugin")
set (PLUGIN_SRM     TRUE CACHE STRING "enable compilation of the srm plugin")
set (PLUGIN_DCAP    TRUE CACHE STRING "enable compilation of the DCAP plugin")
set (PLUGIN_FILE    TRUE CACHE STRING "enable compilation of the local File plugin")
set (PLUGIN_GRIDFTP TRUE CACHE STRING "enable compilation of the GRIDFTP plugin")
set (PLUGIN_HTTP    TRUE CACHE STRING "enable compilation of the HTTP plugin")
set (PLUGIN_XROOTD  TRUE CACHE STRING "enable compilation of the XROOTD plugin")
set (PLUGIN_MOCK    FALSE CACHE STRING "enable compilation of the MOCK plugin")
# Deprecated / unsupported protocols after CC7
set (PLUGIN_LFC     FALSE CACHE STRING "enable compilation of the lfc plugin")
set (PLUGIN_RFIO    FALSE CACHE STRING "enable compilation of the RFIO plugin")

# build type
set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "type of build")

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# load modules
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(CMakeCXX11Support REQUIRED)

# Enable C++11 support
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

# enable testing
include (CTest)

#define PROJECT vars
set (PROJECT_NAME_MAIN "gfal2")
set (OUTPUT_NAME_MAIN "gfal2")

set (PROJECT_NAME_TRANSFER "gfal_transfer")
set (OUTPUT_NAME_TRANSFER "gfal_transfer")

set (VERSION_MAJOR  2)
set (VERSION_MINOR  23)
set (VERSION_PATCH  2)
set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

add_definitions(-DVERSION="${VERSION_STRING}")

# out of project test compilation
set (ONLY_TESTS FALSE CACHE STRING "build only the tests")
set (SKIP_TESTS FALSE CACHE STRING "skip the tests")

# libs checks
find_package (GLIB2 REQUIRED)
find_package (GTHREAD2 REQUIRED)
find_package (JSONC REQUIRED)

# include directories
include_directories (${GLIB2_INCLUDE_DIRS})
include_directories (${GTHREAD2_INCLUDE_DIRS})
include_directories (${CMAKE_SOURCE_DIR}/src/core)
include_directories (${CMAKE_SOURCE_DIR}/src/utils)

# Core and plugins
if (NOT ONLY_TESTS)

    # general parameters for configuration
    add_definitions ( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
    add_definitions ( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )
    # add file offset 64 for 32 bits
    add_definitions ( -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_GNU_SOURCE)

    #install doc license
    install (FILES "LICENSE" "README.md" "RELEASE-NOTES" "DESCRIPTION" "readme.html"
			 DESTINATION ${DOC_INSTALL_DIR})

    # install global configuration files
    list (APPEND lst_conf_files
        "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gfal2_core.conf"
        "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/bdii.conf"
        "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/x509.conf")
    install (FILES ${lst_conf_files}
             DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

    add_subdirectory (doc)
    add_subdirectory (src)

endif (NOT ONLY_TESTS)

if (NOT SKIP_TESTS)
    add_subdirectory (test)
endif (NOT SKIP_TESTS)

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

# Shared utilities can be compiled as static, and then
# included at linking time
add_subdirectory (utils)

set(gfal2_utils_src ${gfal2_utils_src} PARENT_SCOPE)
set(gfal2_utils_c_src ${gfal2_utils_c_src} PARENT_SCOPE)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/utils)

# Core library
if (MAIN_CORE)
	add_subdirectory (core)
	# Command line tool to get GFAL2 version
	add_subdirectory (version)
endif (MAIN_CORE)

# Plugins
add_subdirectory (plugins)

=== src/utils/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

# Dependencies
if (IS_IFCE)
    list (APPEND gfal2_utils_definitions "-DMDS_BDII_EXTERNAL=1")
    set (is_ifce_link "is_ifce")
    list (APPEND src_mds "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds.c")
else (IS_IFCE)
    list (APPEND gfal2_utils_definitions "-DMDS_BDII_EXTERNAL=0")
    find_library(LDAP_LIBRARY NAMES ldap_r ldap)
    list (APPEND is_ifce_link ${LDAP_LIBRARY} "lber")
    list (APPEND src_mds
        "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds.c"
        "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds_internal.c"
        "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds_ldap_internal_layer.c"
    )
endif (IS_IFCE)

find_package (PugiXML)
if (NOT PUGIXML_FOUND)
    message ("PugiXML not found. MDS Cache disabled")
    list (APPEND gfal2_utils_definitions "-DMDS_WITHOUT_CACHE=1")
    set (mds_cache_link "")
else (NOT PUGIXML_FOUND)
    list (APPEND src_mds
        "${CMAKE_CURRENT_SOURCE_DIR}/mds/gfal_mds_cache.cpp"
    )
    set (mds_cache_link "${PUGIXML_LIBRARIES}")
endif (NOT PUGIXML_FOUND)

# Link
list (APPEND gfal2_utils_libraries
    ${is_ifce_link}
    ${mds_cache_link}
    ${JSONC_LIBRARIES}
)

# Sources
file (GLOB src_exceptions   "${CMAKE_CURRENT_SOURCE_DIR}/exceptions/*.c*")
file (GLOB src_gsimplecache "${CMAKE_CURRENT_SOURCE_DIR}/gsimplecache/*.c*")
file (GLOB src_uri          "${CMAKE_CURRENT_SOURCE_DIR}/uri/*.c*")
file (GLOB src_checksums    "${CMAKE_CURRENT_SOURCE_DIR}/checksums/*.c*")
file (GLOB src_space        "${CMAKE_CURRENT_SOURCE_DIR}/space/*.c*")
file (GLOB src_network      "${CMAKE_CURRENT_SOURCE_DIR}/network/*.c*")

list (APPEND gfal2_utils_src ${src_exceptions})

list (APPEND gfal2_utils_c_src
    ${src_gsimplecache}
    ${src_uri}
    ${src_checksums}
    ${src_mds}
    ${src_space}
    ${src_network}
)

set (gfal2_utils_c_src ${gfal2_utils_c_src} PARENT_SCOPE)
set (gfal2_utils_src ${gfal2_utils_src} PARENT_SCOPE)
set (gfal2_utils_libraries ${gfal2_utils_libraries} PARENT_SCOPE)
set (gfal2_utils_definitions ${gfal2_utils_definitions} PARENT_SCOPE)
set (gfal2_utils_includes ${JSONC_INCLUDE_DIRS} PARENT_SCOPE)

# Install public headers
install (FILES "uri/gfal2_uri.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/utils)

=== test/functional/CMakeLists.txt ===
function (add_test_executable name source)
add_executable(${name} ${source})
install(TARGETS ${name}
        DESTINATION ${SHARE_INSTALL_PREFIX}/gfal2/tests)
endfunction(add_test_executable name)


if(FUNCTIONAL_TESTS)
    find_package(GTEST)

    include_directories(
        "${CMAKE_SOURCE_DIR}/src"
        "${CMAKE_SOURCE_DIR}/test"
        "${CMAKE_SOURCE_DIR}/src/posix/"
        "${GLIB2_INCLUDE_DIRS}"
        "${GTEST_INCLUDE_DIR}"
        "${JSONC_INCLUDE_DIRS}"
    )

    # Bring online tests
    add_test_executable(gfal_test_bringonline "gfal_test_bringonline.cpp")
    target_link_libraries(gfal_test_bringonline ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_bringonline name dir_path)
        add_test(gfal_test_bringonline_${name} gfal_test_bringonline ${dir_path})
    endfunction(test_bringonline name valid_file)

    # Archive tests
    add_test_executable(gfal_test_archive "gfal_test_archive.cpp")
    target_link_libraries(gfal_test_archive ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_archive name dir_path)
        add_test(gfal_test_archive_${name} gfal_test_archive ${dir_path})
    endfunction(test_archive name dir_path)

    # Checksum tests
    add_test_executable(gfal_test_checksum "gfal_test_checksum.cpp")
    target_link_libraries(gfal_test_checksum ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_checksum_simple name dir_path algo)
        add_test(gfal_checksum_simple_${name} gfal_test_checksum ${dir_path} ${algo})
    endfunction(test_checksum_simple name valid_file algo)

    # Stat tests
    add_test_executable(gfal_test_stat "gfal_test_stat.cpp")
    target_link_libraries(gfal_test_stat ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_stat_all name valid)
        add_test(gfal_stat_${name} gfal_test_stat ${valid})
    endfunction(test_stat_all valid)

    # Access test
    add_test_executable(gfal_test_access "gfal_test_access.cpp")
    target_link_libraries(gfal_test_access ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_access name dir_path)
        add_test(gfal_test_access_${name} gfal_test_access ${dir_path})
    endfunction(test_access name dir_path)

    # XAttr test
    add_test_executable(gfal_test_xattr "gfal_test_xattr.cpp")
    target_link_libraries(gfal_test_xattr ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_xattr name dir_path)
        add_test(gfal_test_xattr_${name} gfal_test_xattr ${dir_path} ${ARGV2})
    endfunction(test_xattr name dir_path)

    # Deletion tests
    add_test_executable(gfal_test_del "gfal_test_del.cpp")
    target_link_libraries(gfal_test_del ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_del name dir_path)
        add_test(gfal_test_del_${name} gfal_test_del ${dir_path})
    endfunction(test_del name path)

    # QoS tests
    add_test_executable(gfal_test_qos "gfal_test_qos.cpp")
    target_link_libraries(gfal_test_qos ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_qos name)
        add_test(gfal_test_qos_${name} gfal_test_qos)
    endfunction(test_qos name)

    # Token tests
    add_test_executable(gfal_test_token "gfal_test_token.cpp")
    target_link_libraries(gfal_test_token ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_token name)
      add_test(gfal_test_token_${name} gfal_test_token)
    endfunction(test_token name)

    # Rename tests
    add_test_executable(gfal_test_rename "gfal_test_rename.cpp")
    target_link_libraries(gfal_test_rename ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rename name dir_path)
        add_test(gfal_test_rename_${name} gfal_test_rename ${dir_path})
    endfunction(test_rename name dir_path)

    # Chmod tests
    add_test_executable(gfal_test_chmod "gfal_test_chmod.cpp")
    target_link_libraries(gfal_test_chmod ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_chmod_all name valid right1 right2 right3 right4)
        add_test(gfal_test_right_change_${name} gfal_test_chmod ${valid} ${right1} ${right2} ${right3} ${right4})
    endfunction(test_chmod_all name valid right1 right2 right3 right4)

    # Rmdir tests
    add_test_executable(gfal_test_rmdir_full "gfal_test_rmdir_full.cpp")
    target_link_libraries(gfal_test_rmdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rmdir_all name valid_dir)
        add_test(gfal_test_rmdir_full_${name} gfal_test_rmdir_full ${valid_dir})
    endfunction(test_rmdir_all name valid_dir)

    # Readdir tests
    add_test_executable(gfal_test_readdir_full "gfal_test_readdir_full.cpp")
    target_link_libraries(gfal_test_readdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_readdir_full name valid)
            add_test(gfal_test_readdir_full_${name} gfal_test_readdir_full ${valid})
    endfunction(test_readdir_full valid)

    # IO tests
    add_test_executable(gfal_test_rw_full "gfal_test_rw_full.cpp")
    target_link_libraries(gfal_test_rw_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    add_test_executable(gfal_test_rw_seq "gfal_test_rw_seq.cpp")
    target_link_libraries(gfal_test_rw_seq ${GFAL2_LIBRARIES} gfal2_test_shared)

    add_test_executable(gfal_test_rw_seek "gfal_test_rw_seek.cpp")
    target_link_libraries(gfal_test_rw_seek ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_rwt_all name path size)
        add_test(gfal_rw_size_${name} gfal_test_rw_full ${path} ${size})
    endfunction(test_rwt_all name path size)

    function(test_rwt_seq name path size_read size)
        add_test(gfal_rw_seq_${name} gfal_test_rw_seq ${path} ${size_read} ${size})
    endfunction(test_rwt_seq name path size_read size)

    function(test_rwt_seek name path size_read size)
        add_test(gfal_rw_seek_${name} gfal_test_rw_seek ${path} ${size_read} ${size})
    endfunction(test_rwt_seek name path size)

    # Mkdir tests
    add_test_executable(gfal_test_mkdir_full "gfal_test_mkdir_full.cpp")
    target_link_libraries(gfal_test_mkdir_full ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_mkdir_all name prefix)
        add_test(gfal_mkdir_full_${name} gfal_test_mkdir_full ${prefix})
    endfunction(test_mkdir_all name prefix)

    # Register test
    add_test_executable(gfal_test_register "gfal_test_register.cpp")
    target_link_libraries(gfal_test_register ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(test_register name origin lfc)
        add_test(gfal_test_register_${name} gfal_test_register ${origin} ${lfc})
    endfunction(test_register name origin lfc)

    # Set credentials test
    add_test_executable(gfal_test_set_creds "gfal_test_set_creds.cpp")
    target_link_libraries(gfal_test_set_creds ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(gfal_test_set_credentials name prefix)
        add_test(gfal_test_set_credentials_${name} gfal_test_set_creds ${prefix})
    endfunction(gfal_test_set_credentials name prefix)

    # Posix test
    add_test_executable(gfal_test_posix "gfal_test_posix.cpp")
    target_link_libraries(gfal_test_posix ${GFAL2_LIBRARIES} gfal2_test_shared)

    function(gfal_test_posix name prefix)
        add_test(gfal_test_posix_${name} gfal_test_posix ${prefix})
    endfunction(gfal_test_posix name prefix)

    # Space test
    add_test_executable(gfal_test_space "gfal_test_space.cpp")
    target_link_libraries(gfal_test_space ${GFAL2_LIBRARIES} gfal2_test_shared)
    function(test_space name prefix)
        add_test(gfal_test_space_${name} gfal_test_space ${prefix})
    endfunction(test_space name prefix)

    # Tests for file transfer
    if(MAIN_TRANSFER)

		add_test_executable(gfalt_test_rd3_reorder_protocols "gfalt_test_rd3_reorder_protocols.cpp")
        target_link_libraries(gfalt_test_rd3_reorder_protocols ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)
        function(test_rd3_reorder_protocols name src_dir dst_dir)
            add_test(rd3_reorder_protocols_${name} gfalt_test_rd3_reorder_protocols ${src_dir} ${dst_dir})
        endfunction(test_rd3_reorder_protocols name dst_dir)

        add_test_executable(gfalt_test_copy_file_cancel "gfalt_test_copy_file_cancel.cpp")
        target_link_libraries(gfalt_test_copy_file_cancel ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} pthread)

        add_test_executable(gfalt_test_copy_file "gfalt_test_copy_file.cpp")
        target_link_libraries(gfalt_test_copy_file ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_timeout "gfalt_test_copy_file_timeout.cpp")
        target_link_libraries(gfalt_test_copy_file_timeout ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_mkdir "gfalt_test_copy_file_mkdir.cpp")
        target_link_libraries(gfalt_test_copy_file_mkdir ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_replace "gfalt_test_copy_file_replace.cpp")
        target_link_libraries(gfalt_test_copy_file_replace ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_checksum "gfalt_test_copy_file_checksum.cpp")
        target_link_libraries(gfalt_test_copy_file_checksum ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_file_checksum_user "gfalt_test_copy_file_checksum_user.cpp")
        target_link_libraries(gfalt_test_copy_file_checksum_user ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_copy_bulk "gfalt_test_copy_bulk.cpp")
        target_link_libraries(gfalt_test_copy_bulk ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        add_test_executable(gfalt_test_pasv "gfalt_test_pasv.cpp")
        target_link_libraries(gfalt_test_pasv ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        function(test_copy_file_full name src_dir dst_dir)
            add_test(copyfile_checksum_${name} gfalt_test_copy_file_checksum ${src_dir} ${dst_dir})
            add_test(copyfile_checksum_user_${name} gfalt_test_copy_file_checksum_user ${src_dir} ${dst_dir})
            add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
            add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
            add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
        endfunction(test_copy_file_full name dst_dir)

        function (test_copy_bulk name src_dir dst_dir)
            add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
        endfunction (test_copy_bulk name src_dir dst_dir)

        function(test_copy_file_no_checksum name src_dir dst_dir)
            add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
            add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
            add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
        endfunction(test_copy_file_no_checksum name src_dir dst_dir)

        function(test_pasv name src_dir dst_dir)
            add_test(gfalt_test_pasv_${name} gfalt_test_pasv ${src_dir} ${dst_dir})
        endfunction(test_pasv name src_dir dst_dir)

        add_test_executable(gfalt_test_double_cred "gfalt_test_double_cred.cpp")
        target_link_libraries(gfalt_test_double_cred ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} gfal2_test_shared)

        function(test_double_cred name src_dir dst_dir)
            add_test(gfalt_test_double_cred_${name} gfalt_test_double_cred ${src_dir} ${dst_dir})
        endfunction(test_double_cred name src_dir dst_dir)

    endif(MAIN_TRANSFER)

    include(functional-test-parameters.cmake)

    include(functional-test-parameters.cmake)

    # Install ctest file
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/CTestTestfile.cmake
            DESTINATION ${SHARE_INSTALL_PREFIX}/gfal2/tests)

endif(FUNCTIONAL_TESTS)

=== test/unit/CMakeLists.txt ===
find_package (PugiXML)

include_directories(
    "${CMAKE_SOURCE_DIR}/test"
    "${CMAKE_SOURCE_DIR}/src/posix/"
)

add_subdirectory(cancel)
add_subdirectory(config)
add_subdirectory(cred)
add_subdirectory(global)
add_subdirectory(http)
add_subdirectory(mds)
add_subdirectory(transfer)
add_subdirectory(uri)

if (PUGIXML_FOUND)
set (TEST_MDS ./mds/test_mds.cpp)
else (PUGIXML_FOUND)
set (TEST_MDS "")
endif (PUGIXML_FOUND)

if (PLUGIN_HTTP)
    file(GLOB TEST_HTTP_PLUGIN "./http/test_*.cpp")
    set(HTTP_PLUGIN_LIBRARIES  plugin_http_static)

    include     (CheckLibraryExists)
    find_package(Davix REQUIRED)

    # Includes
    include_directories(${DAVIX_INCLUDE_DIR})

else(PLUGIN_HTTP)
    set(TEST_HTTP_PLUGIN "")
    set(HTTP_PLUGIN_LIBRARIES "")
endif (PLUGIN_HTTP)

add_executable(gfal2-unit-tests
    ./cancel/cancel_tests.cpp
    ./config/config_test.cpp
    ./cred/test_cred.cpp
    ./global/global_test.cpp
    ${TEST_HTTP_PLUGIN}
    ${TEST_MDS}
    ./transfer/tests_callbacks.cpp
    ./transfer/tests_params.cpp
    ./uri/test_uri.cpp
    ./uri/test_parsing.cpp
)

target_include_directories(gfal2-unit-tests PRIVATE
    ${CMAKE_SOURCE_DIR}/test
    ${PROJECT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_link_libraries(gfal2-unit-tests
    ${GFAL2_LIBRARIES} ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} gfal2_test_shared ${HTTP_PLUGIN_LIBRARIES}
)

install(TARGETS gfal2-unit-tests
  DESTINATION ${BIN_INSTALL_DIR}/)

add_test(unit-tests gfal2-unit-tests)

=== src/plugins/gridftp/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (PLUGIN_GRIDFTP)
    file (GLOB_RECURSE src_gridftp "*.c*")

    find_package (Globus_FTP_CLIENT REQUIRED)
    find_package (Globus_FTP_CONTROL REQUIRED)
    find_package (Globus_GASS_COPY REQUIRED)
    find_package (Globus_COMMON REQUIRED)
    find_package (Globus_GSS_ASSIST REQUIRED)
    find_package (Globus_GSSAPI_GSI REQUIRED)

    add_definitions( ${GLOBUS_GASS_COPY_CFLAGS})
    add_library (plugin_gridftp MODULE ${src_gridftp})

    target_link_libraries(plugin_gridftp gfal2 gfal2_transfer
                          ${GLOBUS_FTP_CLIENT_LIBRARIES}
                          ${GLOBUS_FTP_CONTROL_LIBRARIES}
			              ${GLOBUS_GASS_COPY_LIBRARIES}
                          ${GLOBUS_GSSAPI_GSI}
                          ${GLOBUS_COMMON_LIBRARIES}
                          ${GLOBUS_GSS_ASSIST_LIBRARIES}
                          ${GLOBUS_GSSAPI_GSI_LIBRARIES})

    include_directories(${GLOBUS_GASS_COPY_INCLUDE_DIRS})

    set_target_properties(plugin_gridftp    PROPERTIES
								LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME "gfal_plugin_gridftp"
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)



    install(TARGETS		plugin_gridftp
	        LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

    install(FILES		"README_PLUGIN_GRIDFTP"
	    	DESTINATION ${DOC_INSTALL_DIR})

    # install gsiftp configuration files
    LIST(APPEND gsiftp_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gsiftp_plugin.conf")
    install(FILES ${gsiftp_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

endif (PLUGIN_GRIDFTP)

=== src/plugins/lfc/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_LFC)
    find_package (LFC REQUIRED)
    find_package (UUID REQUIRED)

    add_definitions (-D_REENTRANT)

    include_directories(${LFC_INCLUDE_DIR} ${LCGDM_INCLUDE_DIR} ${UUID_PKG_INCLUDE_DIR})

    file (GLOB src_lfc "*.c*")
    add_library (plugin_lfc MODULE ${src_lfc})

    target_link_libraries(plugin_lfc
        gfal2 gfal2_transfer
        ${LFC_LIBRARIES}
        ${UUID_PKG_LIBRARIES}
    )

    set_target_properties(plugin_lfc PROPERTIES
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME "gfal_plugin_lfc"
                            LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    install (TARGETS plugin_lfc
             LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR})
    install (FILES "README_PLUGIN_LFC"
             DESTINATION ${DOC_INSTALL_DIR})


    # install lfc configuration files
    LIST(APPEND lfc_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/lfc_plugin.conf")
    install(FILES ${lfc_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)
endif (PLUGIN_LFC)

=== src/plugins/sftp/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (PLUGIN_SFTP)
    find_package (LIBSSH2 REQUIRED)

    include_directories(${LIBSSH2_INCLUDE_DIR})

    file (GLOB src_sftp "*.c*")
    add_library (plugin_sftp MODULE ${src_sftp})

    target_link_libraries(plugin_sftp
        gfal2 gfal2_transfer
        ${LIBSSH2_LIBRARIES}
        ${UUID_PKG_LIBRARIES}
    )

    set_target_properties(plugin_sftp PROPERTIES
        CLEAN_DIRECT_OUTPUT 1
        OUTPUT_NAME "gfal_plugin_sftp"
        LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins
    )

    install (TARGETS plugin_sftp
        LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
    )
    install (FILES "README_PLUGIN_SFTP"
        DESTINATION ${DOC_INSTALL_DIR}
    )

    list (APPEND sftp_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/sftp_plugin.conf")
    install(FILES ${sftp_conf_file}
        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/
    )
endif (PLUGIN_SFTP)

=== test/unit/cred/CMakeLists.txt ===

add_executable(gfal2_cred_test "test_cred.cpp")

target_link_libraries(gfal2_cred_test
    ${GFAL2_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${GTEST_MAIN_LIBRARIES}
    gfal2_test_shared
)

add_test(gfal2_cred_test gfal2_cred_test)

=== test/unit/http/CMakeLists.txt ===
add_executable(gfal2_token_map_test "test_token_map.cpp")
add_executable(gfal2_custom_http_options_test "test_custom_http_options.cpp")
add_executable(gfal2_http_copy_mode_test "test_http_copy_mode.cpp")

find_package(Davix REQUIRED)
find_package(JSONC REQUIRED)

file(GLOB src_http "${CMAKE_SOURCE_DIR}/src/plugins/http/gfal_http_*.cpp")
add_library(test_plugin_http STATIC ${src_http})

target_link_libraries(test_plugin_http
  gfal2
  ${DAVIX_LIBRARIES}
  ${JSONC_LIBRARIES}
  ${CRYPTOPP_LIBRARIES})

set(test_plugin_http_link_libraries
  ${GFAL2_LIBRARIES}
  ${GTEST_LIBRARIES}
  ${GTEST_MAIN_LIBRARIES}
  gfal2_test_shared
  ${DAVIX_LIBRARIES}
  ${CRYPTOPP_LIBRARIES}
  test_plugin_http)

target_include_directories(test_plugin_http PRIVATE
  ${DAVIX_INCLUDE_DIR}
  ${JSONC_INCLUDE_DIRS})

target_link_libraries(gfal2_token_map_test
  ${test_plugin_http_link_libraries})

target_include_directories(gfal2_token_map_test PRIVATE
  ${DAVIX_INCLUDE_DIR})

target_link_libraries(gfal2_custom_http_options_test
  ${test_plugin_http_link_libraries})

target_include_directories(gfal2_custom_http_options_test PRIVATE
  ${DAVIX_INCLUDE_DIR})

target_link_libraries(gfal2_http_copy_mode_test
  ${test_plugin_http_link_libraries})

target_include_directories(gfal2_http_copy_mode_test PRIVATE
  ${DAVIX_INCLUDE_DIR})

add_test(gfal2_token_map_test gfal2_token_map_test)
add_test(gfal2_custom_http_options_test gfal2_custom_http_options_test)
add_test(gfal2_http_copy_mode_test gfal2_http_copy_mode_test)

=== debian/changelog ===
gfal2 (2.23.2-1) unstable; urgency=medium

  * New upstream release 2.23.2

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 08 Apr 2025 09:43:58 +0200

=== debian/control ===
Source: gfal2
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 cmake,
 libattr1-dev [kfreebsd-any],
 libglib2.0-dev,
 libjson-c-dev,
 libldap2-dev,
 libpugixml-dev,
 uuid-dev,
 zlib1g-dev,
 srm-ifce-dev (>= 1.23.1),
 dcap-dev,
 libglobus-gass-copy-dev,
 davix-dev (>= 0.8.4),
 libcrypto++-dev (>= 5.6.2),
 libxrootd-client-dev,
 libssh2-1-dev,
 pkgconf,
 libgtest-dev (>= 1.8.0-7)
Build-Depends-Indep:
 doxygen
Standards-Version: 4.7.2
Section: net
Vcs-Browser: https://salsa.debian.org/ellert/gfal2
Vcs-Git: https://salsa.debian.org/ellert/gfal2.git
Homepage: https://dmc-docs.web.cern.ch/dmc-docs/gfal2/gfal2.html

Package: gfal2
Architecture: all
Multi-Arch: foreign
Depends:
 libgfal2-2t64,
 libgfal-transfer2t64,
 ${misc:Depends}
Recommends:
 gfal2-plugin-file,
 gfal2-plugin-dcap,
 gfal2-plugin-srm,
 gfal2-plugin-gridftp,
 gfal2-plugin-http,
 gfal2-plugin-xrootd,
 gfal2-plugin-sftp
Description: Grid file access library 2.0
 GFAL 2.0 offers a single and simple POSIX-like API for the file
 operations in grids and cloud environments. The set of supported
 protocols depends on the gfal2 installed plugins.

Package: libgfal2-2t64
Provides: ${t64:Provides}
Replaces: libgfal2-2
Breaks: libgfal2-2 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Core of the grid file access library 2.0
 The main library of gfal2. The gfal protocol support relies on a
 plugin system.

Package: libgfal-transfer2t64
Provides: ${t64:Provides}
Replaces: libgfal-transfer2
Breaks: libgfal-transfer2 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: File Transfer logic of gfal2
 gfal-transfer is the high level API for file transfer operations in
 gfal2. It supports third-party copy.

Package: libgfal2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 libgfal-transfer2t64 (= ${binary:Version}),
 libattr1-dev [kfreebsd-any],
 libglib2.0-dev,
 ${misc:Depends}
Description: Development files of gfal2
 Development files for gfal2.

Package: gfal2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: Documentation for gfal2
 Documentation, doxygen and examples of gfal2.

Package: gfal2-plugin-file
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides file support for gfal2
 Provides the file support (file://) for gfal2. The file plugin
 provides local file operations, as copying from local to remote or
 the other way around.

Package: gfal2-plugin-dcap
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 dcap-tunnel-gsi,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides dcap support for gfal2
 Provides the dcap support (gsidcap://, dcap://) for gfal2. The dcap
 plugin provides the POSIX operations for the dcap URLs, the dcap
 protocol is used on the DCACHE storage system.

Package: gfal2-plugin-srm
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 libgfal-transfer2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides srm support for gfal2
 Provides the srm support (srm://) for gfal2. The srm plugin provides
 the POSIX operations and the third party transfer support on the SRM
 URLs.

Package: gfal2-plugin-gridftp
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 libgfal-transfer2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides the gridftp support for gfal2
 Provides the gridftp support (gsiftp://) for gfal2. The gridftp plugin
 provides the POSIX operations and the third party transfer support on
 the GSIFTP URLs.

Package: gfal2-plugin-http
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 libgfal-transfer2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides HTTP and DAV support for gfal2
 Provides the HTTP (http[s]://) and WebDAV (dav[s]://) support for
 gfal2. This plugin is able to do third-party copy with WebDAV if the
 storage supports it.

Package: gfal2-plugin-xrootd
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 libgfal-transfer2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides xrootd support for gfal2
 Provides the xrootd (root://) support for gfal2.

Package: gfal2-plugin-sftp
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 libgfal-transfer2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides sftp support for gfal2
 Provides the sftp (sftp://) support for gfal2.

Package: gfal2-plugin-mock
Architecture: any
Multi-Arch: same
Depends:
 libgfal2-2t64 (= ${binary:Version}),
 libgfal-transfer2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Provides a mock dummy protocol for gfal2
 Provides a dummy mock:// protocol for gfal2.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	   -DSYSCONF_INSTALL_DIR:PATH=/etc \
	   -DLIB_SUFFIX:PATH="/$(DEB_HOST_MULTIARCH)" \
	   -DUNIT_TESTS:BOOL=TRUE \
	   -DPLUGIN_MOCK:BOOL=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_auto_install:
	dh_auto_install
	# Remove
	rm debian/tmp/usr/share/doc/gfal2/LICENSE
	rm debian/tmp/usr/share/doc/gfal2/readme.html
	rm debian/tmp/usr/bin/gfal2-unit-tests
	rm debian/tmp/usr/lib/*/libgfal2_test_shared.so
	# Replace with a script for multi-arch
	printf '#!/bin/sh\necho ' > debian/tmp/usr/bin/gfal2_version.sh
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$${LD_LIBRARY_PATH} \
	   debian/tmp/usr/bin/gfal2_version >> \
	   debian/tmp/usr/bin/gfal2_version.sh
	mv debian/tmp/usr/bin/gfal2_version.sh \
	   debian/tmp/usr/bin/gfal2_version

override_dh_auto_test:
	objdir=obj-$(DEB_HOST_GNU_TYPE) ; \
	export GFAL_PLUGIN_DIR=$(CURDIR)/$${objdir}/plugins ; \
	export GFAL_CONFIG_DIR=$(CURDIR)/$${objdir}/test/conf_test ; \
	dh_auto_test -- "ARGS+=-V"
